# Spellscape Galaxy Project

## Developer Notes

### Config files

The Universe server uses an INI file named **'UniverseDefault.ini'** to retrieve server settings. The planet server uses the file **'PlanetDefault.ini'**. These files should be copied and renamed **'Universe.ini'** and **'Planet.ini'** respectively to be edited. These settings will override default settings found in the Default configs.

While developing and debugging, the viewer also uses this config system and should have its **'ViewerDefault.ini'** file copied to **'Viewer.ini'**

### Visual Studio

Visual Studio 2019 solution is included, make sure that platform is set to x64. Multiple startup projects should be set to run. All projects in the solution should be set to action 'None' except **Galaxy.Server.Universe.exe**, **Galaxy.Server.Planet.exe** and **Galaxy Viewer.exe** which should be set to run in that order. The Universe should then run first followed by Planet and finally the Viewer.

### Server Console Applications

*Galaxy.Server.Universe.exe*
<br>
*Galaxy.Server.Planet.exe*

#### Requirements

1. MySQL Connection details should be set in Universe.ini and Planet.ini pointing to two empty schemas for the Universe and Planet servers to create tables in.
2. The Universe config should also have a file path set pointing to where assets will be saved. Default settings will create this in the server BIN directory under the path 'LiveAssets'

#### First Run

1. When the servers runs for the first time they create the required database tables
2. Create your avatar on the Universe server with the console command **'users create user &#60;NAME&#62; &#60;PASSWORD&#62;'**
3. The servers can be reset and wipe ALL test data using the console command **'admin alpha reset'**

### Viewer Application

*Galaxy Viewer.exe*

Screen size should be automatically detected but this and taskbar widths can be set in Viewer config. If using an En/US keyboard layout, this can also be set using the config.

To connect to the live test server precompiled viewer releases are available which are configured to connect to our test server. These releases are framework Independent and include all runtimes so do not require any preinstalled runtimes.

[Test Viewer Downloads](http://www.spellscape.co.uk/viewer/download)

#### Requirements

1. Visual Studio 2019 and .NET 5 Runtimes
2. MonoGame 3.8, BEPU Physics 2.3 and MySQL are loaded by NuGet and other related dependencies are present in the project
3. Default assets that can not be downloaded from the server because they are used by splash screen pre login will be copied to the build directory automatically. Note all assets fetched at runtime from the server are stored in the BIN directory under the path **'Content\Cache'** which may need to be cleared manually from time to time.
4. Avatar name and password can be set in the viewers Config.ini to prevent needing to type it in the login screen every time. Remember that an account still needs to be created on the Server console.

#### Controls

1. Arrow keys move the avatar
2. Right Mouse hold down and drag side to side to turn avatar
3. Hold shift while walking to run
4. Ctrl to jump
5. In fly mode, the +/- keys increase how fast the avatar moves
6. In fly mode, Page Up/Down Adjust altitude
7. Additional view settings see Settings menu
8. Ctrl+C switch between 3rd and 1st person camera views
9. Ctrl+W Toggle wire frame rendering
10. Ctrl+U Toggle landscape LOD on/off

------------------------------------------
(C) 2022 Spellscape Ltd
